package.path = [[.\lua_lib\?.lua;]] .. package.path
package.cpath = [[.\lua_lib\?.dll;]] .. package.cpath
local 字集码互转库 = require("u8_to_a")
local 字集库 = require("u8_to_a")
local u8 = 字集码互转库.u8_to_a
local f = require(u8("常用库"))
local 字段名对 = require(u8("字段名"))
local 文件系库 = require("lfs")
local 档库 = require("lsqlite3")
local 基算库 = require(字集库.u8_to_a("算机_程语_月_基类_数_基算"))
local 位算库 = require(字集库.u8_to_a("算机_程语_月_基类_数_位算"))
local 前缀库 = require(字集库.u8_to_a("算机_程语_月_基类_文_前缀"))
local 后缀库 = require(字集库.u8_to_a("算机_程语_月_基类_文_后缀"))
local 历排库 = require(字集库.u8_to_a("算机_程语_月_基类_能_传能_历_基类_表_排_取全"))
local 历对库 = require(字集库.u8_to_a("算机_程语_月_基类_能_传能_历_基类_表_对_取全"))
local 历文库 = require(字集库.u8_to_a("算机_程语_月_基类_能_传能_历_基类_文_取全"))
local 历排取一库 = require(字集库.u8_to_a("算机_程语_月_基类_能_传能_历_基类_表_排_取一"))
local 基类库 = require(字集库.u8_to_a("算机_程语_月_基类_能_传能_基类"))
local 历对取一库 = require(字集库.u8_to_a("算机_程语_月_基类_能_传能_历_基类_表_对_取一"))
local 筛卡库 = require(字集库.u8_to_a("游戏王_则拟器_原版_残局_卡_全筛"))
local 对库 = require(字集库.u8_to_a("算机_程语_月_基类_表_对"))
local 字节库 = require(字集库.u8_to_a("算机_理器_通用_字节"))
local 读文件库 = require(字集库.u8_to_a("算机_基统_窗群_文件系_小文件_读"))
local 写文件库 = require(字集库.u8_to_a("算机_基统_窗群_文件系_小文件_写"))
local string = string
local os = os
local d = {}
local 卡档
--~ 各文件的卡对排
function d.筛有效果卡_一维(o1_0)
  return 历排库.历排(o1_0, 筛卡库.筛有效果卡)
  end
--~ 各文件的卡编排
function d.取卡对_一维(o1_0)
  return 历排库.历排(o1_0, d.取卡对)
  end
--~ 卡编
function d.取卡对(o1)
  local k1_0, k2_0
  --~ 卡文对
  k1_0 = d.取卡文(o1)
  --~ 卡数据对
  k2_0 = d.取卡数据(o1)
  return 对库.连两对(k1_0, k2_0)
  end
--~ 卡编
function d.取卡文(o1)
  for o1_4 in 卡档:nrows("select * from texts where id = " .. o1) do
    return o1_4
    end
  end
--~ 卡编
function d.取卡数据(o1)
  for o1_4 in 卡档:nrows("select * from datas where id = " .. o1) do
    return o1_4
    end
  end
--~ 文
function d.局筛卡编(o1)
  local k1_0
  --~ 卡编排
  k1_0 = 历文库.历文(o1, string.gmatch, "[^\n]+")
  k1_0 = 历排库.历排(k1_0, string.match, "Debug%.AddCard.+")
  return 历排库.历排(k1_0, string.match, "[0-9]+")
  end
--~ 文
function d.局筛则数(o1)
  local k1
  local k1_0
  --~ 则数排
  k1_0 = 历文库.历文(o1, string.gmatch, "[^\n]+")
  k1_0 = 历排库.历排(k1_0, 前缀库.全筛前缀, "Debug.ReloadFieldBegin")
  --~ 则数
  k1 = string.match(k1_0[1], "[0-9]")
  return k1 or 3
  end
--~ 卡对排
function d.荐名(o1_0)
  local k1
  --~ 名
  k1 = d.荐字段名(o1_0)
  if k1 then
  else
    k1 = d.荐卡名(o1_0)
    end
  if k1 then
    return k1
  else
    return "请便"
    end
  end
--~ 卡对排
function d.荐卡名(o1_0)
  local k1_0
  --~ 卡名排
  k1_0 = 历排库.历排(o1_0, d.取卡名)
  return 历排取一库.筛最短文(k1_0)
  end
--~ 卡对
function d.取卡名(o1_0)
  return o1_0.name
  end
--~ 卡对排
function d.取字段对(o1_0)
  local k1, k2, k3, k4
  local k1_0
  --~ 字段对
  k1_0 = {}
  for o1 = 1, #o1_0 do
    --~ 字段数
    k1 = 字节库.to_uint64(o1_0[o1].setcode)
    if k1 < 1 then
    else
      if k1 > 0xffffFFFFffff then
        k1 = k1 - 1
      else
        for o2 = 1, 11112222 do
          if k1 < 1 then
            break
          else
            --~ 大字段号
            k2 = 位算库.位和(k1, 0xffff)
            k1 = 位算库.位右移(k1, 基算库.乘法(4, 4))
            --~ 字段名
            k3 = 字段名对[tonumber(k2)]
            if k3 then
              if k1_0[k3] then
                k1_0[k3] = 基算库.加法(k1_0[k3], 1)
              else
                k1_0[k3] = 1
                end
              if k2 > 0xfff then
                --~ 小字段号
                k4 = 位算库.位和(k2, 0xfff)
                k3 = 字段名对[tonumber(k4)]
                if k3 then
                  if k1_0[k3] then
                    k1_0[k3] = 基算库.加法(k1_0[k3], 1)
                  else
                    k1_0[k3] = 1
                    end
                else
                  end
              else
                end
            else
              end
            end
          end
        end
      end
    end
  return k1_0
  end
--~ 卡对排
function d.荐字段名(o1_0)
  local k1
  local k1_0
  --~ 字段对
  k1_0 = d.取字段对(o1_0)
  --~ 最大的字段名数量
  _, k1 = 历对取一库.筛最大值(k1_0)
  --~ 最高频字段名对
  k2_0 = 历对库.历对(k1_0, 历对库.全等筛值, k1)
  return 历对取一库.筛最短键(k2_0)
  end
--~ 目对
function d.残局改名(o1_0)
  local k1, k2
  local k1_0, k2_0, k3_0, k4_0, k5_0, k6_0, k7_0, k8_0, k9_0
  local k10_0
  --~ 文件名排
  k1_0 = 历文库.历文(o1_0.文件目, 文件系库.dir)
  k1_0 = 历排库.历排(k1_0, 后缀库.全筛后缀, ".lua")
  --~ 文件排
  k2_0 = 历排库.历排(k1_0, 后缀库.全筛后缀, ".lua")
  for o1 = 1, #k2_0 do
    k2_0[o1] = 前缀库.加前缀(k2_0[o1], o1_0.文件目)
    k2_0[o1] = 读文件库.读文件(k2_0[o1])
    k2_0[o1] = string.gsub(k2_0[o1], "%-%-" .. "%[(=*)%[" .. ".-" .. "%]%1%]", "")
    k2_0[o1] = string.gsub(k2_0[o1], "%-%-" .. "[^\n]*", "")
    end
  --~ 则数排
  k3_0 = 历排库.历排(k2_0, d.局筛则数)
  --~ 各文件的卡编排
  k4_0 = 历排库.历排(k2_0, d.局筛卡编)
  --~ 各文件的卡对排
  k5_0 = 历排库.历排(k4_0, d.取卡对_一维)
  --~ 有效果卡的卡对排
  k6_0 = 历排库.历排(k5_0, d.筛有效果卡_一维)
  --~ 有效果卡的张数排
  k7_0 = 历排库.历排(k6_0, table.maxn)
  --~ 荐名排
  k8_0 = 历排库.历排(k6_0, d.荐名)
  --~ 新名排
  k9_0 = 历排库.历排(k1_0, string.gsub, 字集库.u8_to_a("　" .. ".+"), "")
  --~ 编号排
  k10_0 = 历排库.历排(k1_0, string.gsub, 字集库.u8_to_a("　" .. ".+"), "")
  for o1 = 1, #k1_0 do
    k9_0[o1] = string.gsub(k9_0[o1], "%." .. "lua".. "$", "")
    k9_0[o1] = 字集库.a_to_u8(o1_0.文件目) .. 字集库.a_to_u8(k9_0[o1]) .. "　" .. k3_0[o1] .. "_" .. k7_0[o1] .. "_" .. k8_0[o1] .. "." .. "lua"
    k1_0[o1] = o1_0.文件目 .. k1_0[o1]
    print(k9_0[o1])
    --~ 新名
    k1 = 字集库.u8_to_a(k9_0[o1])
    --~ os.rename(k1_0[o1], k1)
    --~ 文件
    --~ k2 = 读文件库.读文件(k1)
    --~ k10_0[o1] = 字集库.a_to_u8(k10_0[o1])
    --~ k2 = string.gsub(k2, "Debug" .. "%." .. "SetAIName" .. "[^\n]+", [[Debug.SetAIName("]] .. k10_0[o1] .. [[")]], 1)
    --~ 写文件库.写文件(k2, k1)
    end
  end
d.目对 = {
  ["文件目"] = "../single/"
  , ["卡档路"] = [[D:\install\YGOPro\cards.cdb]]
  }
for o1, o2 in pairs(d.目对) do
  d.目对[o1] = 基类库.操类(o2, "string", 字集库.u8_to_a)
  end
卡档 = 档库.open(d.目对.卡档路)
d.残局改名(d.目对)
